/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2005-2008 by TAKAGI Nobuhisa
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */
/*!
 *  \file   toppers/nm_symbol.hpp
 *  \brief  "nm"ޥɤ륷ܥơ֥򰷤
 *
 *  Υե륯饹
 *  \code
 *  class nm_symbol;
 *  \endcode
 */
#ifndef TOPPERS_NM_SYMBOL_HPP_
#define TOPPERS_NM_SYMBOL_HPP_

#include "toppers/config.hpp"
#include <iosfwd>
#include <string>
#include <map>

namespace toppers
{

  /*!
   *  \class  nm_symbol nm_symbol.hpp "toppers/nm_symbol.hpp"
   *  \brief  `nm'ޥɤ륷ܥơ֥򰷤Υ饹
   *
   *  \sa nm_symbol::entry
   */
  class nm_symbol
  {
  public:
    /*!
     *  \struct entry nm_symbol.hpp "toppers/nm_symbol.hpp"
     *  \brief  ɥ쥹ȥ׾Ǽ빽¤
     *
     *  `nm'ޥɤνϷ̤
     *  \code
     *  01234567 T foo
     *  \endcode
     *  Ȥʤä硢0x01234567 address ˡ'T' type ˳Ǽޤ
     */
    struct entry
    {
      unsigned long address;
      int type;
    };

    /*!
     *  \brief  ǥեȥ󥹥ȥ饯
     */
    nm_symbol() {}
    /*!
     *  \brief  󥹥ȥ饯
     *  \param  istr  ϥȥ꡼
     */
    explicit nm_symbol( std::istream& istr ) { load( istr ); }

    void load( std::istream& istr );
    entry const find( std::string const& symbol ) const; 
  private:
    std::map< std::string, entry > symbol_map_;
  };

}

#endif  // ! TOPPERS_NM_SYMBOL_HPP_
